<?php

namespace booking-assistent;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'cObjekt' => '\\booking-assistent\\StructType\\CObjekt',
            'cBegleitperson' => '\\booking-assistent\\StructType\\CBegleitperson',
            'cBegleitgruppe' => '\\booking-assistent\\StructType\\CBegleitgruppe',
            'cBenutzer' => '\\booking-assistent\\StructType\\CBenutzer',
            'cAdresse' => '\\booking-assistent\\StructType\\CAdresse',
            'cKommunikation' => '\\booking-assistent\\StructType\\CKommunikation',
            'cBankverbindung' => '\\booking-assistent\\StructType\\CBankverbindung',
            'cKurtaxzone' => '\\booking-assistent\\StructType\\CKurtaxzone',
            'cKurtaxort' => '\\booking-assistent\\StructType\\CKurtaxort',
            'cBetriebsart' => '\\booking-assistent\\StructType\\CBetriebsart',
            'cIndivZusatzfelder' => '\\booking-assistent\\StructType\\CIndivZusatzfelder',
            'cFehlermeldungen' => '\\booking-assistent\\StructType\\CFehlermeldungen',
            'fehler' => '\\booking-assistent\\StructType\\Fehler',
            'cIdentifikation' => '\\booking-assistent\\StructType\\CIdentifikation',
            'cKonfigurationsdatensatz' => '\\booking-assistent\\StructType\\CKonfigurationsdatensatz',
            'cKonfigurationsliste' => '\\booking-assistent\\StructType\\CKonfigurationsliste',
            'cParameter' => '\\booking-assistent\\StructType\\CParameter',
            'cLand' => '\\booking-assistent\\StructType\\CLand',
            'cPerson' => '\\booking-assistent\\StructType\\CPerson',
            'cMeldeschein' => '\\booking-assistent\\StructType\\CMeldeschein',
            'cMeldescheinRegister' => '\\booking-assistent\\StructType\\CMeldescheinRegister',
            'cMeldescheinZusatzfelder' => '\\booking-assistent\\StructType\\CMeldescheinZusatzfelder',
            'meldescheine' => '\\booking-assistent\\StructType\\Meldescheine',
            'holeMeldeschein' => '\\booking-assistent\\StructType\\HoleMeldeschein',
            'anfragedaten' => '\\booking-assistent\\StructType\\Anfragedaten',
            'holeMeldescheineRequest' => '\\booking-assistent\\StructType\\HoleMeldescheineRequest',
            'holeMeldescheineResponse' => '\\booking-assistent\\StructType\\HoleMeldescheineResponse',
            'druckeMeldescheineRequest' => '\\booking-assistent\\StructType\\DruckeMeldescheineRequest',
            'meldeschein' => '\\booking-assistent\\StructType\\Meldeschein',
            'druckeMeldescheineResponse' => '\\booking-assistent\\StructType\\DruckeMeldescheineResponse',
            'registerMeldescheineRequest' => '\\booking-assistent\\StructType\\RegisterMeldescheineRequest',
            'cMs' => '\\booking-assistent\\StructType\\CMs',
            'configuration-lists' => '\\booking-assistent\\StructType\\Configuration_lists',
            'generic-response' => '\\booking-assistent\\StructType\\Generic_response',
        );
    }
}
