<?php

namespace booking-assistent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cBetriebsart StructType
 * @subpackage Structs
 */
class CBetriebsart extends AbstractStructBase
{
    /**
     * The betriebsartid
     * Meta information extracted from the WSDL
     * - base: xsd:long
     * - maxInclusive: 16
     * - minInclusive: 1
     * @var int
     */
    public $betriebsartid;
    /**
     * The bezeichnung
     * @var string
     */
    public $bezeichnung;
    /**
     * Constructor method for cBetriebsart
     * @uses CBetriebsart::setBetriebsartid()
     * @uses CBetriebsart::setBezeichnung()
     * @param int $betriebsartid
     * @param string $bezeichnung
     */
    public function __construct($betriebsartid = null, $bezeichnung = null)
    {
        $this
            ->setBetriebsartid($betriebsartid)
            ->setBezeichnung($bezeichnung);
    }
    /**
     * Get betriebsartid value
     * @return int|null
     */
    public function getBetriebsartid()
    {
        return $this->betriebsartid;
    }
    /**
     * Set betriebsartid value
     * @param int $betriebsartid
     * @return \booking-assistent\StructType\CBetriebsart
     */
    public function setBetriebsartid($betriebsartid = null)
    {
        // validation for constraint: int
        if (!is_null($betriebsartid) && !(is_int($betriebsartid) || ctype_digit($betriebsartid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($betriebsartid, true), gettype($betriebsartid)), __LINE__);
        }
        // validation for constraint: maxInclusive(16)
        if (!is_null($betriebsartid) && $betriebsartid > 16) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically less than or equal to 16', var_export($betriebsartid, true)), __LINE__);
        }
        // validation for constraint: minInclusive(1)
        if (!is_null($betriebsartid) && $betriebsartid < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically greater than or equal to 1', var_export($betriebsartid, true)), __LINE__);
        }
        $this->betriebsartid = $betriebsartid;
        return $this;
    }
    /**
     * Get bezeichnung value
     * @return string|null
     */
    public function getBezeichnung()
    {
        return $this->bezeichnung;
    }
    /**
     * Set bezeichnung value
     * @param string $bezeichnung
     * @return \booking-assistent\StructType\CBetriebsart
     */
    public function setBezeichnung($bezeichnung = null)
    {
        // validation for constraint: string
        if (!is_null($bezeichnung) && !is_string($bezeichnung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bezeichnung, true), gettype($bezeichnung)), __LINE__);
        }
        $this->bezeichnung = $bezeichnung;
        return $this;
    }
}
