<?php

namespace booking-assistent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for druckeMeldescheineRequest StructType
 * @subpackage Structs
 */
class DruckeMeldescheineRequest extends AbstractStructBase
{
    /**
     * The meldeschein
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \booking-assistent\StructType\Meldeschein[]
     */
    public $meldeschein;
    /**
     * The identifikation
     * @var \booking-assistent\StructType\CIdentifikation
     */
    public $identifikation;
    /**
     * Constructor method for druckeMeldescheineRequest
     * @uses DruckeMeldescheineRequest::setMeldeschein()
     * @uses DruckeMeldescheineRequest::setIdentifikation()
     * @param \booking-assistent\StructType\Meldeschein[] $meldeschein
     * @param \booking-assistent\StructType\CIdentifikation $identifikation
     */
    public function __construct(array $meldeschein = array(), \booking-assistent\StructType\CIdentifikation $identifikation = null)
    {
        $this
            ->setMeldeschein($meldeschein)
            ->setIdentifikation($identifikation);
    }
    /**
     * Get meldeschein value
     * @return \booking-assistent\StructType\Meldeschein[]
     */
    public function getMeldeschein()
    {
        return $this->meldeschein;
    }
    /**
     * This method is responsible for validating the values passed to the setMeldeschein method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeldeschein method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeldescheinForArrayConstraintsFromSetMeldeschein(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $druckeMeldescheineRequestMeldescheinItem) {
            // validation for constraint: itemType
            if (!$druckeMeldescheineRequestMeldescheinItem instanceof \booking-assistent\StructType\Meldeschein) {
                $invalidValues[] = is_object($druckeMeldescheineRequestMeldescheinItem) ? get_class($druckeMeldescheineRequestMeldescheinItem) : sprintf('%s(%s)', gettype($druckeMeldescheineRequestMeldescheinItem), var_export($druckeMeldescheineRequestMeldescheinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The meldeschein property can only contain items of type \booking-assistent\StructType\Meldeschein, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set meldeschein value
     * @throws \InvalidArgumentException
     * @param \booking-assistent\StructType\Meldeschein[] $meldeschein
     * @return \booking-assistent\StructType\DruckeMeldescheineRequest
     */
    public function setMeldeschein(array $meldeschein = array())
    {
        // validation for constraint: array
        if ('' !== ($meldescheinArrayErrorMessage = self::validateMeldescheinForArrayConstraintsFromSetMeldeschein($meldeschein))) {
            throw new \InvalidArgumentException($meldescheinArrayErrorMessage, __LINE__);
        }
        $this->meldeschein = $meldeschein;
        return $this;
    }
    /**
     * Add item to meldeschein value
     * @throws \InvalidArgumentException
     * @param \booking-assistent\StructType\Meldeschein $item
     * @return \booking-assistent\StructType\DruckeMeldescheineRequest
     */
    public function addToMeldeschein(\booking-assistent\StructType\Meldeschein $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \booking-assistent\StructType\Meldeschein) {
            throw new \InvalidArgumentException(sprintf('The meldeschein property can only contain items of type \booking-assistent\StructType\Meldeschein, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->meldeschein[] = $item;
        return $this;
    }
    /**
     * Get identifikation value
     * @return \booking-assistent\StructType\CIdentifikation|null
     */
    public function getIdentifikation()
    {
        return $this->identifikation;
    }
    /**
     * Set identifikation value
     * @param \booking-assistent\StructType\CIdentifikation $identifikation
     * @return \booking-assistent\StructType\DruckeMeldescheineRequest
     */
    public function setIdentifikation(\booking-assistent\StructType\CIdentifikation $identifikation = null)
    {
        $this->identifikation = $identifikation;
        return $this;
    }
}
