<?php

namespace booking-assistent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for druckeMeldescheineResponse StructType
 * @subpackage Structs
 */
class DruckeMeldescheineResponse extends AbstractStructBase
{
    /**
     * The fehlermeldungen
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \booking-assistent\StructType\CFehlermeldungen
     */
    public $fehlermeldungen;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 10
     * - minOccurs: 0
     * @var string
     */
    public $version;
    /**
     * The ms_pdf
     * Meta information extracted from the WSDL
     * - base: xsd:base64Binary
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ms_pdf;
    /**
     * Constructor method for druckeMeldescheineResponse
     * @uses DruckeMeldescheineResponse::setFehlermeldungen()
     * @uses DruckeMeldescheineResponse::setVersion()
     * @uses DruckeMeldescheineResponse::setMs_pdf()
     * @param \booking-assistent\StructType\CFehlermeldungen $fehlermeldungen
     * @param string $version
     * @param string $ms_pdf
     */
    public function __construct(\booking-assistent\StructType\CFehlermeldungen $fehlermeldungen = null, $version = null, $ms_pdf = null)
    {
        $this
            ->setFehlermeldungen($fehlermeldungen)
            ->setVersion($version)
            ->setMs_pdf($ms_pdf);
    }
    /**
     * Get fehlermeldungen value
     * @return \booking-assistent\StructType\CFehlermeldungen
     */
    public function getFehlermeldungen()
    {
        return $this->fehlermeldungen;
    }
    /**
     * Set fehlermeldungen value
     * @param \booking-assistent\StructType\CFehlermeldungen $fehlermeldungen
     * @return \booking-assistent\StructType\DruckeMeldescheineResponse
     */
    public function setFehlermeldungen(\booking-assistent\StructType\CFehlermeldungen $fehlermeldungen = null)
    {
        $this->fehlermeldungen = $fehlermeldungen;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \booking-assistent\StructType\DruckeMeldescheineResponse
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        // validation for constraint: maxLength(10)
        if (!is_null($version) && mb_strlen($version) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 10', mb_strlen($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Get ms_pdf value
     * @return string|null
     */
    public function getMs_pdf()
    {
        return $this->{'ms-pdf'};
    }
    /**
     * Set ms_pdf value
     * @param string $ms_pdf
     * @return \booking-assistent\StructType\DruckeMeldescheineResponse
     */
    public function setMs_pdf($ms_pdf = null)
    {
        // validation for constraint: string
        if (!is_null($ms_pdf) && !is_string($ms_pdf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ms_pdf, true), gettype($ms_pdf)), __LINE__);
        }
        $this->ms_pdf = $this->{'ms-pdf'} = $ms_pdf;
        return $this;
    }
}
