<?php

namespace booking-assistent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for holeMeldescheineResponse StructType
 * @subpackage Structs
 */
class HoleMeldescheineResponse extends AbstractStructBase
{
    /**
     * The fehlermeldungen
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \booking-assistent\StructType\CFehlermeldungen
     */
    public $fehlermeldungen;
    /**
     * The meldescheine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \booking-assistent\StructType\CMeldeschein[]
     */
    public $meldescheine;
    /**
     * Constructor method for holeMeldescheineResponse
     * @uses HoleMeldescheineResponse::setFehlermeldungen()
     * @uses HoleMeldescheineResponse::setMeldescheine()
     * @param \booking-assistent\StructType\CFehlermeldungen $fehlermeldungen
     * @param \booking-assistent\StructType\CMeldeschein[] $meldescheine
     */
    public function __construct(\booking-assistent\StructType\CFehlermeldungen $fehlermeldungen = null, array $meldescheine = array())
    {
        $this
            ->setFehlermeldungen($fehlermeldungen)
            ->setMeldescheine($meldescheine);
    }
    /**
     * Get fehlermeldungen value
     * @return \booking-assistent\StructType\CFehlermeldungen
     */
    public function getFehlermeldungen()
    {
        return $this->fehlermeldungen;
    }
    /**
     * Set fehlermeldungen value
     * @param \booking-assistent\StructType\CFehlermeldungen $fehlermeldungen
     * @return \booking-assistent\StructType\HoleMeldescheineResponse
     */
    public function setFehlermeldungen(\booking-assistent\StructType\CFehlermeldungen $fehlermeldungen = null)
    {
        $this->fehlermeldungen = $fehlermeldungen;
        return $this;
    }
    /**
     * Get meldescheine value
     * @return \booking-assistent\StructType\CMeldeschein[]|null
     */
    public function getMeldescheine()
    {
        return $this->meldescheine;
    }
    /**
     * This method is responsible for validating the values passed to the setMeldescheine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeldescheine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeldescheineForArrayConstraintsFromSetMeldescheine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $holeMeldescheineResponseMeldescheineItem) {
            // validation for constraint: itemType
            if (!$holeMeldescheineResponseMeldescheineItem instanceof \booking-assistent\StructType\CMeldeschein) {
                $invalidValues[] = is_object($holeMeldescheineResponseMeldescheineItem) ? get_class($holeMeldescheineResponseMeldescheineItem) : sprintf('%s(%s)', gettype($holeMeldescheineResponseMeldescheineItem), var_export($holeMeldescheineResponseMeldescheineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The meldescheine property can only contain items of type \booking-assistent\StructType\CMeldeschein, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set meldescheine value
     * @throws \InvalidArgumentException
     * @param \booking-assistent\StructType\CMeldeschein[] $meldescheine
     * @return \booking-assistent\StructType\HoleMeldescheineResponse
     */
    public function setMeldescheine(array $meldescheine = array())
    {
        // validation for constraint: array
        if ('' !== ($meldescheineArrayErrorMessage = self::validateMeldescheineForArrayConstraintsFromSetMeldescheine($meldescheine))) {
            throw new \InvalidArgumentException($meldescheineArrayErrorMessage, __LINE__);
        }
        $this->meldescheine = $meldescheine;
        return $this;
    }
    /**
     * Add item to meldescheine value
     * @throws \InvalidArgumentException
     * @param \booking-assistent\StructType\CMeldeschein $item
     * @return \booking-assistent\StructType\HoleMeldescheineResponse
     */
    public function addToMeldescheine(\booking-assistent\StructType\CMeldeschein $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \booking-assistent\StructType\CMeldeschein) {
            throw new \InvalidArgumentException(sprintf('The meldescheine property can only contain items of type \booking-assistent\StructType\CMeldeschein, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->meldescheine[] = $item;
        return $this;
    }
}
